;;;; macosx-test

(require-extension test)
(require-extension macosx-env)
(require-extension macosx-url)

(define (print-info)
  (print "     session-info:  " (session-info))
  (print "     machine-name:  " (machine-name))
  (print "  short-user-name:  " (short-user-name))
  (print "   long-user-name:  " (long-user-name))
  (print " machine-location:  " (machine-location))
  (print "          metric?:  " (metric?))
  (print "    computer-name:  " (computer-name))
  (print "     console-user:  " (console-user))
  (print "  local-host-name:  " (local-host-name))
  (print "    location-name:  " (location-name))
  (print " main-bundle-path:  " (main-bundle-path))
  (print "       tick-count:  " (tick-count))
  (print "    gestalt 'addr:  " (gestalt 'addr)) )

(define (delay-test ticks)
  (print* "* Delaying for " ticks " ticks ...")
  (delay-for-ticks ticks)
  (print " Done *")
  (newline) )

(test-group "macosx-env" 
  (test-assert (session-info))
  (test-assert (machine-name))
  (test-assert (short-user-name))
  (test-assert (long-user-name))
  (test-assert (machine-location))
  (test-assert (boolean? (metric?)))
  (test-assert (computer-name))
  (test-assert (console-user))
  (test-assert (local-host-name))
  (test-assert (location-name))
  (test-assert (main-bundle-path))
  (test-assert (tick-count))
  (test-assert (gestalt 'addr))
)

(delay-test 50)

(print-info)

(test-group "macosx-url - should launch default browser with \"http://www.apple.com/\"" 
  (open-url "http://www.apple.com/")
)
